Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_vhdl_body.cpp	(revision 134)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_vhdl_body.cpp	(revision 135)
@@ -23,5 +23,295 @@
   {
     log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");
-    vhdl->set_body ("");
+
+    vhdl->set_comment(0,"=========================================");
+    vhdl->set_comment(0,"===== CONSTANT ==========================");
+    vhdl->set_comment(0,"=========================================");
+    vhdl->set_body   (0,"");
+    vhdl->set_body   (0,"internal_ICACHE_RSP_ACK                               <= '1';");
+    vhdl->set_body   (0,"internal_EVENT_RESET_ACK                              <= '1';");
+    vhdl->set_body   (0,"out_EVENT_RESET_ACK                                   <= '1';");
+    vhdl->set_body   (0,"out_ICACHE_RSP_ACK                                    <= '1';");
+    vhdl->set_body   (0,"");
+    vhdl->set_comment(0,"---------------------------------------------------------------------------");
+    vhdl->set_comment(0,"TRANSLATION ");
+    vhdl->set_comment(0,"---------------------------------------------------------------------------");
+    vhdl->set_body   (0,"TRANSITION : process (in_CLOCK)");
+    vhdl->set_body   (0,"variable have_instruction_decod         : std_logic;");
+    vhdl->set_body   (0,"variable have_instruction_enable        : std_logic;");
+    //    vhdl->set_body   (0,"variable reg_INSTRUCTION_ENABLE_VAR     : std_logic;");
+    if (_param->_size_queue>1) {
+    vhdl->set_body   (0,"variable var_PTR_READ                   :"+ std_logic(log2(_param->_size_queue))+";");
+    vhdl->set_body   (0,"variable var_PTR_WRITE                  :"+ std_logic(log2(_param->_size_queue))+";");
+    }
+//     vhdl->set_body   (0,"variable var_EMPTY                      : std_logic;");
+    vhdl->set_body   (0,"variable var_STATE                      :  Tstate;");
+    vhdl->set_body   (0,"variable var_INSTRUCTION_ENABLE         :  Tenable;");
+    vhdl->set_body   (0,"variable var_ADDRESS                    :  Tadress;");
+    if(_param->_have_port_inst_ifetch_ptr)
+    vhdl->set_body   (0,"variable var_INST_IFETCH_PTR            : Tinst_ptr;");
+    vhdl->set_body   (0,"variable var_BRANCH_STATE               : Tbranch_state;");
+    if(_param->_have_port_depth)
+    vhdl->set_body   (0,"variable var_BRANCH_UPDATE_PREDICTION_ID      : "+std_logic(_param->_size_depth)+";");
+    //    vhdl->set_body   (0,"variable var_internal_ICACHE_RSP_ACK    : std_logic;");
+    if (_param->_have_port_ifetch_queue_ptr)
+    vhdl->set_body   (0,"variable var_internal_ICACHE_RSP_PACKET_ID    : "+std_logic(_param->_size_ifetch_queue_ptr)+";");
+    vhdl->set_body   (0,"variable var_EXCEPTION                  : Texception;");
+
+
+    vhdl->set_body   (0,"begin  -- TRANSITION");
+    vhdl->set_body   (1,"if (in_CLOCK'event and in_CLOCK = '1')then");
+    vhdl->set_body   (0,"");
+    vhdl->set_comment(2,"---------------------------------------------------------------------------");
+    vhdl->set_comment(2,"Reset");
+    vhdl->set_comment(2,"---------------------------------------------------------------------------");
+    vhdl->set_body   (2,"if (in_NRESET = '0') then");
+    if (_param->_size_queue>1) 
+      {
+	vhdl->set_body   (3,"reg_PTR_READ  <= "+std_logic_cst( log2(_param->_size_queue), 0)+";");
+	vhdl->set_body   (3,"reg_PTR_WRITE <= "+std_logic_cst( log2(_param->_size_queue), 0)+";");
+      }
+//     vhdl->set_body     (3,"var_EMPTY := '1';");
+    
+    for (uint32_t i=0; i<_param->_size_queue; i++)
+      {
+  	vhdl->set_body (3,"reg_STATE("+toString(i)+")  <= IFETCH_QUEUE_STATE_EMPTY;");
+      }
+
+    vhdl->set_body   (3,"");
+    vhdl->set_body   (2,"else");
+    vhdl->set_body   (3,"");
+    //    std::string write = (_param->_size_queue==1)?"0":"conv_integer(reg_PTR_WRITE)";
+    //    vhdl->set_body (3,"var_STATE                                  := reg_STATE ("+write+");");
+    vhdl->set_body (3,"var_STATE                                  := reg_STATE ;");
+    if (_param->_size_queue>1) 
+      {
+	vhdl->set_body   (3,"var_PTR_READ                           := reg_PTR_READ;");
+	vhdl->set_body   (3,"var_PTR_WRITE                          := reg_PTR_WRITE;");
+      }
+
+//     if (_param->_size_queue>1)
+//       {
+//     vhdl->set_body   (3,"var_EMPTY                       := reg_EMPTY                      ;");
+//       }
+    vhdl->set_body   (3,"var_INSTRUCTION_ENABLE          := reg_INSTRUCTION_ENABLE         ;");
+    vhdl->set_body   (3,"var_ADDRESS                     := reg_ADDRESS                    ;");
+    if(_param->_have_port_inst_ifetch_ptr)
+    vhdl->set_body   (3,"var_INST_IFETCH_PTR             := reg_INST_IFETCH_PTR            ;");
+    if (_param->_have_port_ifetch_queue_ptr)
+      //    vhdl->set_body   (3,"var_BRANCH_UPDATE_PREDICTION_ID := reg_BRANCH_UPDATE_PREDICTION_ID;");
+    vhdl->set_body   (3,"var_BRANCH_STATE                := reg_BRANCH_STATE               ;");
+    vhdl->set_body   (3,"var_EXCEPTION                   := reg_EXCEPTION                  ;");
+
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    vhdl->set_comment(3,"ADDRESS ");
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    {
+    std::string reg_ptr_write = (_param->_size_queue==1)?"0":"conv_integer(reg_PTR_WRITE)";
+    vhdl->set_body (3,"if ((in_ADDRESS_VAL and internal_ADDRESS_ACK) = '1') then");
+    vhdl->set_body   (3,"var_STATE ("+reg_ptr_write+")              := IFETCH_QUEUE_STATE_WAIT_RSP;");
+    for (uint32_t i=0; i<_param->_nb_instruction; i++)
+    vhdl->set_body   (3,"var_INSTRUCTION_ENABLE ("+reg_ptr_write+")("+toString(i)+")   := in_address_"+toString(i)+"_instruction_enable;");
+
+    vhdl->set_body   (3,"var_ADDRESS("+reg_ptr_write+")                                := in_ADDRESS_INSTRUCTION_ADDRESS;");
+    if(_param->_have_port_inst_ifetch_ptr)
+      {
+	vhdl->set_body   (3,"var_INST_IFETCH_PTR("+reg_ptr_write+")                    := in_ADDRESS_INST_IFETCH_PTR;");
+      }
+    vhdl->set_body   (3,"var_BRANCH_STATE("+reg_ptr_write+")                           := in_ADDRESS_BRANCH_STATE;");
+    if(_param->_have_port_depth)
+      vhdl->set_body   (3,"var_BRANCH_UPDATE_PREDICTION_ID          := in_ADDRESS_BRANCH_UPDATE_PREDICTION_ID;");
+    if (_param->_size_queue>1) 
+      {
+	vhdl->set_body   (3,"if (var_PTR_WRITE ="+std_logic_cst( log2(_param->_size_queue),_param->_size_queue-1)+") then");
+	vhdl->set_body   (3,"var_PTR_WRITE                          := "+std_logic_cst( log2(_param->_size_queue), 0)+";");
+	vhdl->set_body   (3,"else");
+	if (_param->_size_ifetch_queue_ptr == 1)
+	vhdl->set_body   (3,"var_PTR_WRITE                          := not var_PTR_WRITE;");
+	else
+	vhdl->set_body   (3,"var_PTR_WRITE                          := (var_PTR_WRITE +"+std_logic_cst( log2(_param->_size_queue),1)+");");
+	vhdl->set_body (3,"end if;");
+      }
+    vhdl->set_body (3,"end if;");
+    }
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    vhdl->set_comment(3,"DECOD ");
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    
+// 	have_instruction_decod <= ((internal_DECOD_0_VAL and in_DECOD_0_ACK) or
+// 				   (internal_DECOD_1_VAL and in_DECOD_1_ACK) or
+// 				   (internal_DECOD_2_VAL and in_DECOD_2_ACK) or
+// 				   (internal_DECOD_3_VAL and in_DECOD_3_ACK));
+    vhdl->set_body   (3,"have_instruction_decod  := '0';");
+    vhdl->set_body   (3,"have_instruction_enable := '0';");
+    std::string reg_ptr_read = (_param->_size_queue==1)?"0":"conv_integer(reg_PTR_READ)"; 
+    for (uint32_t i=0; i<_param->_nb_instruction; i++)
+      {
+	vhdl->set_body (3,"if ((internal_DECOD_"+toString(i)+"_VAL and in_DECOD_"+toString(i)+"_ACK) = '1') then");
+	vhdl->set_body (4,"have_instruction_decod                    := '1';");
+	vhdl->set_body (4,"var_INSTRUCTION_ENABLE ("+reg_ptr_read+")("+toString(i)+")  := '0';");
+	vhdl->set_body (3,"end if;");
+	vhdl->set_body (4,"have_instruction_enable                   := have_instruction_enable or var_INSTRUCTION_ENABLE ("+reg_ptr_read+")("+toString(i)+");");
+      }
+    vhdl->set_body (3,"if (have_instruction_decod = '1') then");
+    vhdl->set_body (3,"if (have_instruction_enable = '0') then");
+    vhdl->set_body (4,"var_STATE ("+reg_ptr_read+")                  := IFETCH_QUEUE_STATE_EMPTY;");
+    
+    if(_param->_size_queue>1) 
+      {
+	vhdl->set_body   (4,"if (var_PTR_READ ="+std_logic_cst( log2(_param->_size_queue),_param->_size_queue-1)+") then");
+	vhdl->set_body   (4,"var_PTR_READ                            := "+std_logic_cst( log2(_param->_size_queue), 0)+";  else");
+	if (_param->_size_ifetch_queue_ptr == 1)
+	vhdl->set_body   (4,"var_PTR_READ                            := not var_PTR_READ;");
+	else
+	vhdl->set_body   (4,"var_PTR_READ                            := var_PTR_READ +"+std_logic_cst( log2(_param->_size_queue),1)+";");
+	vhdl->set_body   (4,"end if;");
+      }
+    vhdl->set_body (3,"end if;");
+    vhdl->set_body (3,"end if;");
+    
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    vhdl->set_comment(3,"ICACHE_RSP ");
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+       {       std::string address;
+       if (_param->_have_port_ifetch_queue_ptr)
+	 {
+	   address="conv_integer(var_internal_ICACHE_RSP_PACKET_ID)";
+	 }
+       else
+	 {
+	   address="0";
+	 }
+       vhdl->set_body (3,"if ((in_ICACHE_RSP_VAL and internal_ICACHE_RSP_ACK)= '1') then");
+       if (_param->_have_port_ifetch_queue_ptr)
+	 {
+	   vhdl->set_body(4,"var_internal_ICACHE_RSP_PACKET_ID      := in_ICACHE_RSP_PACKET_ID;");
+	 }
+       for (uint32_t i=0; i<_param->_nb_instruction; i++)
+	 vhdl->set_body(3,"reg_DATA("+address+")("+toString(i)+") <= in_ICACHE_RSP_"+toString(i)+"_INSTRUCTION ;");
+       
+       vhdl->set_body(4,"if (in_ICACHE_RSP_ERROR                   = ICACHE_ERROR_NONE) then");
+       vhdl->set_body(5,"var_EXCEPTION("+address+")               := EXCEPTION_IFETCH_NONE;");
+       vhdl->set_body(4,"else if (in_ICACHE_RSP_ERROR              = ICACHE_ERROR_BUS_ERROR) then");
+       vhdl->set_body(5,"var_EXCEPTION("+address+")               := EXCEPTION_IFETCH_BUS_ERROR;");
+       vhdl->set_body (4,"end if;");
+       vhdl->set_body (4,"end if;");
+       vhdl->set_body(4,"if (var_STATE("+address+")                = IFETCH_QUEUE_STATE_WAIT_RSP) then");
+       vhdl->set_body(5," var_STATE("+address+")                  := IFETCH_QUEUE_STATE_HAVE_RSP;");
+       vhdl->set_body(4,"else if var_STATE("+address+")            = IFETCH_QUEUE_STATE_ERROR_WAIT_RSP then");
+       vhdl->set_body(5," var_STATE("+address+")                  := IFETCH_QUEUE_STATE_EMPTY;");
+       vhdl->set_body (4,"end if;");
+       vhdl->set_body (4,"end if;");
+       vhdl->set_body (3,"end if;");
+     }
+    
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    vhdl->set_comment(3,"EVENT_RESET");    
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    vhdl->set_body (3,"if ((in_EVENT_RESET_VAL and internal_EVENT_RESET_ACK) = '1' ) then");
+    for (uint32_t i=0; i<_param->_size_queue; i++) {
+      vhdl->set_body(4,"if (var_STATE("+toString(i)+")        = IFETCH_QUEUE_STATE_ERROR_WAIT_RSP) then ");
+      vhdl->set_body(4,"var_STATE("+toString(i)+")           := IFETCH_QUEUE_STATE_ERROR_WAIT_RSP;");
+      vhdl->set_body(4,"else if var_STATE("+toString(i)+")    = IFETCH_QUEUE_STATE_WAIT_RSP        then ");
+      vhdl->set_body(4,"var_STATE("+toString(i)+")           := IFETCH_QUEUE_STATE_ERROR_WAIT_RSP;");
+      vhdl->set_body(4,"else var_STATE("+toString(i)+")      := IFETCH_QUEUE_STATE_EMPTY;");
+      if (_param->_size_queue>1)
+	vhdl->set_body(5,"var_PTR_READ                    := var_PTR_WRITE;");
+//       else
+// 	vhdl->set_body(5,"reg_EMPTY                       <= '1';");
+
+      vhdl->set_body(4,"end if;");
+      vhdl->set_body(4,"end if;");
+    }
+    //vhdl->set_body (3,"end if;");
+    vhdl->set_body (3,"end if;");
+
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    vhdl->set_comment(3,"WRITE Register");
+    vhdl->set_comment(3,"---------------------------------------------------------------------------");
+    {
+    if (_param->_size_queue>1) {
+    vhdl->set_body (3,"reg_PTR_READ                                                <= var_PTR_READ;");
+    vhdl->set_body (3,"reg_PTR_WRITE                                               <= var_PTR_WRITE;");
+    }
+//     vhdl->set_body (3,"reg_EMPTY                                                   <= var_EMPTY;");
+    std::string reg_ptr_write = (_param->_size_queue==1)?"0":"conv_integer(reg_PTR_WRITE)";
+    //    vhdl->set_body (3,"reg_STATE             ("+reg_ptr_write+")                   <= var_STATE;");
+    vhdl->set_body (3,"reg_STATE                                                   <= var_STATE;");
+    for (uint32_t i=0; i<_param->_nb_instruction; i++)
+    vhdl->set_body (3,"reg_INSTRUCTION_ENABLE("+reg_ptr_write+")("+toString(i)+")  <= var_INSTRUCTION_ENABLE("+reg_ptr_write+")("+toString(i)+");");
+    //    vhdl->set_body (3,"reg_ADDRESS           ("+reg_ptr_write+")                   <= var_ADDRESS;");
+    vhdl->set_body (3,"reg_ADDRESS                                                 <= var_ADDRESS;");
+    if(_param->_have_port_inst_ifetch_ptr)
+      //    vhdl->set_body (3,"reg_INST_IFETCH_PTR   ("+reg_ptr_write+")                   <= var_INST_IFETCH_PTR;");
+    vhdl->set_body (3,"reg_INST_IFETCH_PTR                                         <= var_INST_IFETCH_PTR;");
+    //    vhdl->set_body (3,"reg_BRANCH_STATE      ("+reg_ptr_write+")                   <= var_BRANCH_STATE;");
+    vhdl->set_body (3,"reg_BRANCH_STATE                                            <= var_BRANCH_STATE;");
+    if(_param->_have_port_depth)
+    vhdl->set_body (3,"reg_BRANCH_UPDATE_PREDICTION_ID("+reg_ptr_write+")          <= var_BRANCH_UPDATE_PREDICTION_ID;");
+    if (_param->_size_queue>1) 
+    vhdl->set_body (3,"reg_PTR_WRITE                                               <= var_PTR_WRITE;");
+
+    std::string reg_ptr_read = (_param->_size_queue==1)?"0":"conv_integer(reg_PTR_READ)"; 
+    for (uint32_t i=0; i<_param->_nb_instruction; i++)
+    vhdl->set_body (3,"reg_INSTRUCTION_ENABLE("+reg_ptr_read+") ("+toString(i)+")  <= var_INSTRUCTION_ENABLE("+reg_ptr_read+")("+toString(i)+");");
+    //    vhdl->set_body (3,"reg_STATE("+reg_ptr_read+")                                 <= var_STATE;");
+    if(_param->_size_queue>1) 
+    vhdl->set_body (3,"reg_PTR_READ                                                <= var_PTR_READ ;");
+    //    vhdl->set_body (3,"internal_ICACHE_RSP_ACK                                     <= internal_ICACHE_RSP_ACK;");
+    if (_param->_have_port_ifetch_queue_ptr)
+      {
+    vhdl->set_body (3,"internal_ICACHE_RSP_PACKET_ID                               <= var_internal_ICACHE_RSP_PACKET_ID;");
+    std::string address;
+    if (_param->_have_port_ifetch_queue_ptr)
+  	address="conv_integer(var_internal_ICACHE_RSP_PACKET_ID)";
+      else
+      	address="0";
+    //    vhdl->set_body (3,"reg_EXCEPTION("+address+")                                  <= var_EXCEPTION;");
+    vhdl->set_body (3,"reg_EXCEPTION                                               <= var_EXCEPTION;");
+      }
+    }
+    vhdl->set_body (2,"end if;");
+    vhdl->set_body (1,"end if;");
+    vhdl->set_body (0,"end process; -- TRANSITION");
+    
+
+     vhdl->set_comment(0,"---------------------------------------------------------------------------");
+     vhdl->set_comment(0,"GENMOORE");
+     vhdl->set_comment(0,"---------------------------------------------------------------------------");
+     vhdl->set_comment(0,"---------------------------------------------------------------------------");
+     vhdl->set_comment(0,"ADDRESS ");
+     vhdl->set_comment(0,"---------------------------------------------------------------------------");
+     {
+       std::string reg_ptr_write = (_param->_size_queue==1)?"0":"conv_integer(reg_PTR_WRITE)";
+       vhdl->set_body (1,"internal_ADDRESS_ACK          <= '1' WHEN (reg_STATE("+reg_ptr_write+") = IFETCH_QUEUE_STATE_EMPTY) ELSE");
+       vhdl->set_body (1,"'0';"); 
+       vhdl->set_body (1,"out_ADDRESS_ACK               <= internal_ADDRESS_ACK;");
+       if (_param->_have_port_ifetch_queue_ptr) {
+	 vhdl->set_body (1,"out_ADDRESS_IFETCH_QUEUE_ID <= reg_PTR_WRITE;");
+       }
+     }
+     vhdl->set_comment(0,"---------------------------------------------------------------------------");
+     vhdl->set_comment(0,"DECOD ");
+     vhdl->set_comment(0,"---------------------------------------------------------------------------");
+     {
+       std::string reg_ptr_read = (_param->_size_queue==1)?"0":"conv_integer(reg_PTR_READ)";
+       vhdl->set_body (0,"internal_ack <= '1' WHEN (reg_STATE("+reg_ptr_read+") = IFETCH_QUEUE_STATE_HAVE_RSP) ELSE");
+       vhdl->set_body (0,"'0';"); 
+       for (uint32_t j=0; j<_param->_nb_instruction; j++) 
+	 {
+	   vhdl->set_body(0,"internal_DECOD_"+toString(j)+"_VAL <= (internal_ack AND reg_INSTRUCTION_ENABLE("+reg_ptr_read+")("+toString(j)+"));");
+	   vhdl->set_body(0,"out_DECOD_"+toString(j)+"_VAL                   <= internal_DECOD_"+toString(j)+"_VAL;");
+	   vhdl->set_body(0,"out_DECOD_"+toString(j)+"_INSTRUCTION           <= reg_DATA("+reg_ptr_read+")("+toString(j)+") ;");
+	 }
+       vhdl->set_body(0,"out_DECOD_ADDRESS                                   <= reg_ADDRESS("+reg_ptr_read+");");
+       if (_param->_have_port_inst_ifetch_ptr) 
+	 vhdl->set_body(0,"out_DECOD_INST_IFETCH_PTR                         <= reg_INST_IFETCH_PTR("+reg_ptr_read+");");
+       vhdl->set_body(0,"out_DECOD_BRANCH_STATE                              <= reg_BRANCH_STATE("+reg_ptr_read+");");
+       if (_param->_have_port_depth)
+	 vhdl->set_body(0,"out_DECOD_BRANCH_UPDATE_PREDICTION_ID             <= reg_BRANCH_UPDATE_PREDICTION_ID("+reg_ptr_read+");");
+       vhdl->set_body(0,"out_DECOD_EXCEPTION                                 <= reg_EXCEPTION("+reg_ptr_read+");");
+     }
+     vhdl->set_body(0,"");
+
     log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_vhdl_declaration.cpp	(revision 134)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_vhdl_declaration.cpp	(revision 135)
@@ -23,4 +23,70 @@
   {
     log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");
+
+    vhdl->set_constant ("IFETCH_QUEUE_STATE_EMPTY           ",IFETCH_QUEUE_STATE_SIZE,IFETCH_QUEUE_STATE_EMPTY);
+//  vhdl->set_constant ("IFETCH_QUEUE_STATE_WAIT_REQ        ",IFETCH_QUEUE_STATE_SIZE,IFETCH_QUEUE_STATE_WAIT_REQ);
+    vhdl->set_constant ("IFETCH_QUEUE_STATE_WAIT_RSP        ",IFETCH_QUEUE_STATE_SIZE,IFETCH_QUEUE_STATE_WAIT_RSP);
+    vhdl->set_constant ("IFETCH_QUEUE_STATE_HAVE_RSP        ",IFETCH_QUEUE_STATE_SIZE,IFETCH_QUEUE_STATE_HAVE_RSP);
+    vhdl->set_constant ("IFETCH_QUEUE_STATE_ERROR_WAIT_RSP  ",IFETCH_QUEUE_STATE_SIZE,IFETCH_QUEUE_STATE_ERROR_WAIT_RSP);
+    
+    vhdl->set_constant ("EXCEPTION_IFETCH_NONE              ",_param->_size_exception_ifetch,EXCEPTION_IFETCH_NONE);
+    vhdl->set_constant ("EXCEPTION_IFETCH_BUS_ERROR         ",_param->_size_exception_ifetch,EXCEPTION_IFETCH_BUS_ERROR);
+
+    vhdl->set_constant ("ICACHE_ERROR_NONE                  ",_param->_size_icache_error,ICACHE_ERROR_NONE);    
+    vhdl->set_constant ("ICACHE_ERROR_BUS_ERROR             ",_param->_size_icache_error,ICACHE_ERROR_BUS_ERROR);    
+
+    if (_param->_size_queue>1)
+      {
+    vhdl->set_signal  ("reg_PTR_READ                        ", log2(_param->_size_queue));
+    vhdl->set_signal  ("reg_PTR_WRITE                       ", log2(_param->_size_queue));
+      }
+     if (_param->_have_port_ifetch_queue_ptr)
+       {
+	 if (_param->_size_queue>1)
+	   vhdl->set_signal  ("reg_PACKET_PTR                 ", log2(_param->_size_queue));
+	 else 
+	   vhdl->set_signal  ("reg_PACKET_PTR                 ", 1);
+       }
+
+    vhdl->set_signal  ("reg_EMPTY                            ", 1);	
+
+    vhdl->set_type    ("Tcase                                ","array ("+toString(_param->_nb_instruction-1)+" downto 0) of "+std_logic(_param->_size_instruction));
+    vhdl->set_type    ("Tcase_enable                         ","array ("+toString(_param->_nb_instruction-1)+" downto 0) of std_logic");
+
+    vhdl->set_type    ("Tstate                               ","array ("+toString(_param->_size_queue-1)+" downto 0) of "+std_logic(IFETCH_QUEUE_STATE_SIZE));
+    vhdl->set_signal  ("reg_STATE                            ", "Tstate");
+   
+    vhdl->set_type    ("Tqueue                               ","array ("+toString(_param->_size_queue-1)+" downto 0) of Tcase");
+    vhdl->set_signal  ("reg_DATA                             ", "Tqueue");
+    
+    vhdl->set_type    ("Tenable                              ","array ("+toString(_param->_size_queue-1)+" downto 0) of Tcase_enable");
+    vhdl->set_signal  ("reg_INSTRUCTION_ENABLE               ", "Tenable");
+    vhdl->set_type    ("Tadress                              ","array ("+toString(_param->_size_queue-1)+" downto 0) of "+std_logic(_param->_size_instruction));
+    vhdl->set_signal  ("reg_ADDRESS                          ", "Tadress");
+
+    if (_param->_have_port_inst_ifetch_ptr) 
+      {
+       vhdl->set_type    ("Tinst_ptr                         ","array ("+toString(_param->_size_queue-1)+" downto 0) of "+std_logic(_param->_size_inst_ifetch_ptr));
+       vhdl->set_signal  ("reg_INST_IFETCH_PTR               ", "Tinst_ptr");
+      }
+    if (_param->_have_port_depth)
+      {
+	vhdl->set_type    ("Tbranch                           ","array ("+toString(_param->_size_queue-1)+" downto 0) of "+std_logic(_param->_size_depth));
+	vhdl->set_signal  ("reg_BRANCH_UPDATE_PREDICTION_ID   ", "Tbranch");
+      }
+    vhdl->set_type    ("Tbranch_state                         ","array ("+toString(_param->_size_queue-1)+" downto 0) of "+std_logic(_param->_size_branch_state));
+    vhdl->set_signal  ("reg_BRANCH_STATE                      ", "Tbranch_state");
+    vhdl->set_type    ("Texception                            ","array ("+toString(_param->_size_queue-1)+" downto 0) of "+std_logic(_param->_size_exception_ifetch));
+    vhdl->set_signal  ("reg_EXCEPTION                         ", "Texception"); 
+    
+    for (uint32_t i=0; i<_param->_nb_instruction; ++i)
+    vhdl->set_signal  ("internal_DECOD_"+toString(i)+"_VAL                      ", 1);
+    vhdl->set_signal  ("internal_ADDRESS_ACK                  ", 1);    
+    vhdl->set_signal  ("internal_ICACHE_RSP_ACK               ", 1);
+    vhdl->set_signal  ("internal_EVENT_RESET_ACK              ", 1);
+    if(_param->_have_port_ifetch_queue_ptr)
+    vhdl->set_signal  ("internal_ICACHE_RSP_PACKET_ID         ", _param->_size_ifetch_queue_ptr);
+    vhdl->set_signal  ("internal_ack                          ", 1);
+
     log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters.cpp	(revision 134)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters.cpp	(revision 135)
@@ -38,5 +38,5 @@
       {
         _size_instruction_address   = size_general_data;
-        _size_ifetch_queue_ptr      = log2(size_queue);
+        _size_ifetch_queue_ptr      = log2(_size_queue);
         _size_inst_ifetch_ptr       = log2(nb_instruction);
         _size_depth                 = size_branch_update_prediction;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Branch_Target_Buffer_Register_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Branch_Target_Buffer_Register_allocation.cpp	(revision 134)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Branch_Target_Buffer_Register_allocation.cpp	(revision 135)
@@ -74,5 +74,5 @@
       ALLOC2_SIGNAL_OUT(out_PREDICT_ADDRESS_SRC ,"address_src" ,Tgeneral_data_t    ,_param->_size_instruction_address);
       ALLOC2_SIGNAL_OUT(out_PREDICT_ADDRESS_DEST,"address_dest",Tgeneral_data_t    ,_param->_size_instruction_address);
-      ALLOC2_SIGNAL_OUT(out_PREDICT_CONDITION   ,"condition"   ,Tbranch_condition_t,_param->_size_branch_state);
+      ALLOC2_SIGNAL_OUT(out_PREDICT_CONDITION   ,"condition"   ,Tbranch_condition_t,_param->_size_branch_condition);
       ALLOC2_SIGNAL_OUT(out_PREDICT_LAST_TAKE   ,"last_take"   ,Tcontrol_t         ,1);
       ALLOC2_SIGNAL_OUT(out_PREDICT_IS_ACCURATE ,"is_accurate" ,Tcontrol_t         ,1);
@@ -96,5 +96,5 @@
       ALLOC1_SIGNAL_IN ( in_DECOD_ADDRESS_SRC    ,"address_src"    ,Tgeneral_data_t    ,_param->_size_instruction_address);
       ALLOC1_SIGNAL_IN ( in_DECOD_ADDRESS_DEST   ,"address_dest"   ,Tgeneral_data_t    ,_param->_size_instruction_address);
-      ALLOC1_SIGNAL_IN ( in_DECOD_CONDITION      ,"condition"      ,Tbranch_condition_t,_param->_size_branch_state);
+      ALLOC1_SIGNAL_IN ( in_DECOD_CONDITION      ,"condition"      ,Tbranch_condition_t,_param->_size_branch_condition);
       ALLOC1_SIGNAL_IN ( in_DECOD_LAST_TAKE      ,"last_take"      ,Tcontrol_t         ,1);
       ALLOC1_SIGNAL_IN ( in_DECOD_MISS_PREDICTION,"miss_prediction",Tcontrol_t         ,1);
@@ -119,5 +119,5 @@
       ALLOC1_SIGNAL_IN ( in_UPDATE_ADDRESS_SRC    ,"address_src"    ,Tgeneral_data_t    ,_param->_size_instruction_address);
       ALLOC1_SIGNAL_IN ( in_UPDATE_ADDRESS_DEST   ,"address_dest"   ,Tgeneral_data_t    ,_param->_size_instruction_address);
-      ALLOC1_SIGNAL_IN ( in_UPDATE_CONDITION      ,"condition"      ,Tbranch_condition_t,_param->_size_branch_state);
+      ALLOC1_SIGNAL_IN ( in_UPDATE_CONDITION      ,"condition"      ,Tbranch_condition_t,_param->_size_branch_condition);
       ALLOC1_SIGNAL_IN ( in_UPDATE_LAST_TAKE      ,"last_take"      ,Tcontrol_t         ,1);
       ALLOC1_SIGNAL_IN ( in_UPDATE_MISS_PREDICTION,"miss_prediction",Tcontrol_t         ,1);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 134)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 135)
@@ -156,5 +156,5 @@
 //    ALLOC1_SIGNAL_IN ( in_COMMIT_OPERATION         ,"operation"  ,Toperation_t      ,_param->_size_operation       );
 //    ALLOC1_SIGNAL_IN ( in_COMMIT_TYPE              ,"type"       ,Ttype_t           ,_param->_size_type            );
-      ALLOC1_SIGNAL_IN ( in_COMMIT_FLAGS             ,"flags"      ,Tspecial_data_t   ,_param->_size_general_data    );
+      ALLOC1_SIGNAL_IN ( in_COMMIT_FLAGS             ,"flags"      ,Tspecial_data_t   ,_param->_size_special_data    );
       ALLOC1_SIGNAL_IN ( in_COMMIT_EXCEPTION         ,"exception"  ,Texception_t      ,_param->_size_exception       );
       ALLOC1_SIGNAL_IN ( in_COMMIT_NO_SEQUENCE       ,"no_sequence",Tcontrol_t        ,1                             );
